void setup() {
  Serial.begin(115200);
  Serial.setTimeout(0);
  pinMode(2, OUTPUT);  // frequency is kbytes/sec
  pinMode(3, OUTPUT);  // duty cycle is CPU free time
}

byte pinstate=LOW;

void loop() {
  char buf[500];
  int count=0;
  int n;
  
  // receive 500 bytes, using Serial.readBytes
  // as many times as necessary until all 500
  while (count < 500) {
    n = Serial.readBytes(buf+count, 500-count);
    if (n == 0) {
      digitalWrite(3, HIGH);
      while (!Serial.available()) ; // wait
      digitalWrite(3, LOW); 
    }
    count = count + n;
  }
  
  // toggle pin 2, so the frequency is kbytes/sec
  if (pinstate == LOW) {
    digitalWrite(2, HIGH);
    pinstate = HIGH;
  } else {
    digitalWrite(2, LOW);
    pinstate = LOW;
  }
}
